"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Alert = void 0;
var React = __importStar(require("react"));
var core_1 = require("@material-ui/core");
var color_1 = require("../core/style/color");
var classnames_1 = __importDefault(require("classnames"));
var build_1 = require("react-persistent-state/build");
var height = function (dense) { return dense ? 44 : 52; };
var useStyles = core_1.makeStyles(function (t) { return core_1.createStyles({
    root: t.mixins.gutters({
        transition: t.transitions.create('all'),
        // @ts-ignore
        minHeight: function (props) { return height(props.dense); },
        display: 'flex',
        alignItems: 'center',
        overflow: 'hidden',
        borderRadius: 4,
        // @ts-ignore
        paddingLeft: function (props) { return props.dense ? t.spacing(1) : t.spacing(2); },
    }),
    i: {
        marginRight: t.spacing(1),
        height: function (props) { return height(props.dense) + "px !important"; },
        display: 'flex',
        alignItems: 'center',
        alignSelf: 'flex-start',
    },
    body: {
        flex: 1,
        paddingTop: function (props) { return t.spacing(props.dense ? 1 : 2); },
        paddingBottom: function (props) { return t.spacing(props.dense ? 1 : 2); },
    },
    _success: {
        background: 'rgba(50, 255, 150, .16)',
        color: color_1.colorSuccess,
    },
    _info: {
        background: 'rgba(50, 200, 255, .16)',
        color: color_1.colorInfo,
    },
    _error: {
        background: 'rgba(255, 0, 0, .16)',
        color: color_1.colorError,
    },
    _warning: {
        background: 'rgba(255, 128, 0, .16)',
        color: color_1.colorWarning,
    },
    _hidden: {
        minHeight: '0 !important',
        height: '0 !important',
        opacity: '0 !important',
        margin: '0 !important',
    },
    action: {
        textAlign: 'right',
        margin: t.spacing(1) + " " + t.spacing(1 / 2) + " " + t.spacing(1 / 2) + " 0",
        marginRight: -t.spacing(2),
    }
}); });
var Alert = function (_a) {
    var id = _a.id, style = _a.style, type = _a.type, dense = _a.dense, children = _a.children, icon = _a.icon, action = _a.action, deletable = _a.deletable, className = _a.className;
    var classes = useStyles({ type: type, dense: dense, children: children, icon: icon, action: action, deletable: deletable, className: className });
    var _b = build_1.usePersistentState(true, id || 'alert'), isVisible = _b[0], setIsVisible = _b[1];
    var getIconFromType = function () {
        switch (type) {
            case 'info':
                return 'info';
            case 'error':
                return 'error';
            case 'warning':
                return 'warning';
            case 'success':
                return 'check_circle';
            default:
                return 'info';
        }
    };
    return (React.createElement("div", { id: id, className: classnames_1.default(classes.root, classes['_' + type], className, !isVisible && classes._hidden), style: style },
        React.createElement(core_1.Icon, { className: classes.i }, icon ? icon : getIconFromType()),
        React.createElement("div", { className: classes.body }, children),
        React.createElement("div", { className: classes.action },
            action,
            deletable &&
                React.createElement(core_1.IconButton, { onClick: function () { return setIsVisible(false); } },
                    React.createElement(core_1.Icon, null, "clear")))));
};
exports.Alert = Alert;
//# sourceMappingURL=Alert.js.map