"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Btn = void 0;
var React = __importStar(require("react"));
var core_1 = require("@material-ui/core");
var classnames_1 = __importDefault(require("classnames"));
var color_1 = require("../core/style/color");
var useStyles = core_1.makeStyles(function (t) { return core_1.createStyles({
    progress: {
        position: 'absolute',
        top: '50%',
        left: '50%',
        marginTop: -12,
        marginLeft: -12,
    },
    label: {
        display: 'flex',
        alignItems: 'center',
    },
    icon: {
        height: '22px !important',
        lineHeight: '22px !important',
        fontSize: '22px !important',
        marginRight: t.spacing(1)
    },
    iconAfter: {
        marginRight: 0,
        marginLeft: t.spacing(1),
    },
    labelHidden: {
        visibility: 'hidden',
    },
    error_text: {
        color: color_1.colorError,
    },
    error_outlined: {
        color: color_1.colorError,
        borderColor: core_1.fade(color_1.colorError, .4),
    },
    error_contained: {
        background: color_1.colorError,
        color: 'white',
        '&:hover': {
            background: core_1.fade(color_1.colorError, .8),
        }
    },
}); });
var Btn = function (_a) {
    var loading = _a.loading, children = _a.children, disabled = _a.disabled, icon = _a.icon, iconAfter = _a.iconAfter, color = _a.color, className = _a.className, props = __rest(_a, ["loading", "children", "disabled", "icon", "iconAfter", "color", "className"]);
    var classes = useStyles({});
    return (React.createElement(core_1.Button, __assign({}, props, { color: color === 'error' ? 'default' : color, className: classnames_1.default(className, color === 'error' && (classes['error_' + props.variant])), disabled: disabled || loading }),
        React.createElement("div", { className: classnames_1.default(classes.label, loading && classes.labelHidden) },
            icon && React.createElement(core_1.Icon, { className: classes.icon }, icon),
            children,
            iconAfter && React.createElement(core_1.Icon, { className: classnames_1.default(classes.icon, classes.iconAfter) }, iconAfter)),
        loading && React.createElement(core_1.CircularProgress, { size: 24, className: classes.progress })));
};
exports.Btn = Btn;
//# sourceMappingURL=Btn.js.map