"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withGlobalProgress = exports.useGlobalProgressState = exports.useGlobalProgress = exports.progressbarAnimationDuration = exports.GlobalProgressContext = void 0;
var React = __importStar(require("react"));
var react_1 = require("react");
var autobind_decorator_1 = __importDefault(require("autobind-decorator"));
exports.GlobalProgressContext = React.createContext({});
exports.progressbarAnimationDuration = 400;
var GlobalProgressProvider = /** @class */ (function (_super) {
    __extends(GlobalProgressProvider, _super);
    function GlobalProgressProvider() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            currentStep: 0,
            steps: 1,
            started: false,
            progressStart: _this.start,
            progressStop: _this.stop,
            progressComplete: _this.complete,
            progressNext: _this.next,
            promisesWithProgress: _this.promisesWithProgress,
        };
        _this.timeouts = [];
        return _this;
    }
    GlobalProgressProvider.prototype.render = function () {
        return (React.createElement(exports.GlobalProgressContext.Provider, { value: this.state }, this.props.children));
    };
    GlobalProgressProvider.prototype.componentWillUnmount = function () {
        this.clearTimeouts();
    };
    GlobalProgressProvider.prototype.start = function (steps) {
        if (steps === void 0) { steps = 1; }
        this.clearTimeouts();
        this.setState({
            started: true,
            currentStep: 0,
            steps: steps,
        });
    };
    GlobalProgressProvider.prototype.promisesWithProgress = function () {
        var _this = this;
        var promises = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            promises[_i] = arguments[_i];
        }
        this.start(promises.length);
        return promises.map(function (p) { return p
            .then(function (_) {
            _this.next();
            return _;
        })
            .catch(function (_) {
            _this.stop();
            return Promise.reject(_);
        }); });
    };
    GlobalProgressProvider.prototype.stop = function () {
        this.setState({
            started: false,
            currentStep: 0,
        });
    };
    GlobalProgressProvider.prototype.complete = function () {
        if (this.state.started) {
            this.setState(function (state) { return ({
                currentStep: state.steps,
            }); }, this.stopHandlingAnimation);
        }
    };
    GlobalProgressProvider.prototype.next = function () {
        var _this = this;
        if (this.state.started) {
            this.setState(function (state) { return ({
                currentStep: Math.min(state.currentStep + 1, state.steps),
            }); }, function () { return _this.state.currentStep === _this.state.steps && _this.stopHandlingAnimation(); });
        }
    };
    GlobalProgressProvider.prototype.stopHandlingAnimation = function () {
        var _this = this;
        this.setTimeout(function () { return _this.setState({ started: false }); }, exports.progressbarAnimationDuration);
        this.setTimeout(function () { return _this.setState({ currentStep: 0 }); }, exports.progressbarAnimationDuration * 2);
    };
    GlobalProgressProvider.prototype.setTimeout = function (fn, duration) {
        this.timeouts.push(window.setTimeout(fn, duration));
    };
    GlobalProgressProvider.prototype.clearTimeouts = function () {
        this.timeouts.map(clearTimeout);
        this.timeouts = [];
    };
    __decorate([
        autobind_decorator_1.default
    ], GlobalProgressProvider.prototype, "start", null);
    __decorate([
        autobind_decorator_1.default
    ], GlobalProgressProvider.prototype, "promisesWithProgress", null);
    __decorate([
        autobind_decorator_1.default
    ], GlobalProgressProvider.prototype, "stop", null);
    __decorate([
        autobind_decorator_1.default
    ], GlobalProgressProvider.prototype, "complete", null);
    __decorate([
        autobind_decorator_1.default
    ], GlobalProgressProvider.prototype, "next", null);
    return GlobalProgressProvider;
}(React.Component));
exports.default = GlobalProgressProvider;
var useGlobalProgress = function () {
    var _a = react_1.useContext(exports.GlobalProgressContext), progressStart = _a.progressStart, progressStop = _a.progressStop, progressComplete = _a.progressComplete, progressNext = _a.progressNext, promisesWithProgress = _a.promisesWithProgress;
    return {
        progressStart: progressStart,
        progressStop: progressStop,
        progressComplete: progressComplete,
        progressNext: progressNext,
        promisesWithProgress: promisesWithProgress,
    };
};
exports.useGlobalProgress = useGlobalProgress;
var useGlobalProgressState = function () {
    var _a = react_1.useContext(exports.GlobalProgressContext), currentStep = _a.currentStep, steps = _a.steps, started = _a.started;
    return {
        currentStep: currentStep,
        steps: steps,
        started: started,
    };
};
exports.useGlobalProgressState = useGlobalProgressState;
var withGlobalProgress = function (Component) { return function (props) { return (React.createElement(exports.GlobalProgressContext.Consumer, null, function (other /*WithProgress*/) { return React.createElement(Component, __assign({}, props, other)); })); }; };
exports.withGlobalProgress = withGlobalProgress;
//# sourceMappingURL=GlobalProgressContext.js.map