import { ReactNode } from 'react';
export interface WithToast {
    toastError: (m: string) => void;
    toastSuccess: (m: string) => void;
    toastWarning: (m: string) => void;
    toastInfo: (m: string) => void;
    toastLoading: (m: string) => void;
}
export interface ToastProviderProps {
    children: ReactNode;
    vertical?: 'top' | 'bottom';
    horizontal?: 'left' | 'center' | 'right';
}
export declare const ToastProvider: ({ children, vertical, horizontal }: ToastProviderProps) => JSX.Element;
export declare const useToast: () => WithToast;
export declare const withToast: (Component: any) => (props: any) => JSX.Element;
