"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Txt = void 0;
var core_1 = require("@material-ui/core");
var classnames_1 = __importDefault(require("classnames"));
var React = __importStar(require("react"));
var utils_1 = require("@material-ui/core/utils");
var lab_1 = require("@material-ui/lab");
var useStyles = core_1.makeStyles(function (t) { return ({
    root: {
        display: 'inline',
        lineHeight: '1.5',
    },
    block: {
        display: 'block',
    },
    bold: {
        fontWeight: t.typography.fontWeightMedium,
    },
    title: {
        fontSize: '1.30rem',
    },
    big: {
        fontSize: '1.10rem',
    },
    small: {
        fontSize: '0.85rem',
    },
    italic: {
        fontStyle: 'italic'
    },
    gutterBottom: {
        marginBottom: t.spacing(1),
    },
    colorPrimary: {
        color: t.palette.primary.main,
    },
    colorSecondary: {
        color: t.palette.secondary.main,
    },
    colorDisabled: {
        color: t.palette.text.disabled,
    },
    colorHint: {
        color: t.palette.text.secondary,
    },
    colorError: {
        color: t.palette.error.main,
    },
    colorDefault: {
        color: t.palette.text.primary,
    },
    link: {
        color: t.palette.primary.main,
    },
    skeleton: {
        marginTop: 0,
        marginBottom: 0,
        height: 'auto',
        color: 'transparent',
        display: 'block',
    },
    skeletonBlock: {
        display: 'inline-block',
    },
    uppercase: {
        textTransform: 'uppercase',
    },
    noWrap: {
        whiteSpace: 'nowrap',
    },
    truncate: {
        whiteSpace: 'nowrap',
        textOverflow: 'ellipsis',
        overflow: 'hidden',
    },
}); });
var Txt = function (_a) {
    var skeleton = _a.skeleton, children = _a.children, gutterBottom = _a.gutterBottom, block = _a.block, bold = _a.bold, size = _a.size, link = _a.link, italic = _a.italic, color = _a.color, uppercase = _a.uppercase, truncate = _a.truncate, noWrap = _a.noWrap, className = _a.className, otherProps = __rest(_a, ["skeleton", "children", "gutterBottom", "block", "bold", "size", "link", "italic", "color", "uppercase", "truncate", "noWrap", "className"]);
    var css = useStyles();
    var classes = classnames_1.default(css.root, gutterBottom && css.gutterBottom, bold && css.bold, (function () {
        switch (size) {
            case 'big':
                return css.big;
            case 'title':
                return css.title;
            case 'small':
                return css.small;
        }
    })(), italic && css.italic, block && css.block, link && css.link, uppercase && css.uppercase, truncate && css.truncate, noWrap && css.noWrap, color && css['color' + utils_1.capitalize(color)], className);
    return (React.createElement("div", __assign({ className: classes }, otherProps), skeleton ?
        (React.createElement(lab_1.Skeleton, { className: classnames_1.default(css.skeleton, block && css.skeletonBlock), width: isNaN(skeleton) ? '80%' : skeleton }, "_")) : (children)));
};
exports.Txt = Txt;
//# sourceMappingURL=Txt.js.map