"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useInterval = void 0;
var react_1 = require("react");
var useInterval = function (callback, ms) {
    var savedCallback = react_1.useRef();
    react_1.useEffect(function () {
        savedCallback.current = callback;
    });
    react_1.useEffect(function () {
        var tick = function () { return savedCallback.current(); };
        var id = setInterval(tick, ms);
        return function () { return clearInterval(id); };
    }, [ms]);
};
exports.useInterval = useInterval;
//# sourceMappingURL=useInterval.js.map